> ## Documentation Index
> Fetch the complete documentation index at: https://docs.renaiss.xyz/llms.txt
> Use this file to discover all available pages before exploring further.

# 准备购买卡牌

> 按买家已确认的卖价准备购买，获取待买家签名的订单。 调试面板使用测试网请求格式。当前主网字段见本页说明。

提交买家确认过的挂牌价。若价格已变化，请[刷新订单簿](https://docs.renaiss.xyz/cn/api-reference/marketplace/get-orders.md)并展示新价格。买家签名后，[提交购买](https://docs.renaiss.xyz/cn/api-reference/marketplace/buy-card.md)。

在测试网上，发送 `expiresAt: null` 可使用默认到期时间。主网更新前，请同时省略 `expiresAt` 和 `expiresInSeconds` 以使用主网默认值。

提交购买请求时，买家授予 Permit2 的 USDT 额度必须足以支付订单金额。

## 请求

需要开发者密钥

## 响应

## 错误码

在下表中查找接口返回的 HTTP 状态码和响应原文。有关各接口通用的处理建议，请参阅[错误码含义与处理方式](https://docs.renaiss.xyz/cn/api-reference/errors.md)。

| HTTP | 错误码 | 文本字段 | 响应文本与处理方式 |
| :- | :- | :- | :- |
| `400` | `MATCHING_ASK_NOT_FOUND` | `error` | `Ask is no longer available` 藏品没有有效挂牌。请刷新挂牌列表，不要重复发送原请求。 |
| `400` | `MATCHING_ASK_PERMIT_NOT_FOUND` | `error` | `Stored ask payload is invalid` 该挂牌无法购买。请刷新挂牌列表，不要重复发送原请求。 |
| `400` | `WRONG_REQUEST_PARAMS` | `error` | `Invalid marketplace request: tokenId: Required` `Invalid marketplace request: expiresAt: Required` `expiresAt must be null or a future UTC timestamp within 180 days` 检查报错中提到的字段。要使用默认有效期，请传入 `"expiresAt": null`。 |
| `400` | 无错误码 | `text/plain` | `Malformed JSON in request body` |
| `401` | `API_AUTH_INVALID_CREDENTIAL` | `error` | `Invalid authentication credential` 开发者密钥格式错误、未知、已过期或已撤销。请核对并更换密钥。 |
| `401` | `API_AUTH_MISSING_CREDENTIAL` | `error` | `Required authentication credential is missing` 请在 `x-builder-api-key` 请求头中提供开发者密钥。 |
| `403` | `API_AUTH_CREDENTIAL_NOT_ALLOWED` | `error` | `Credential is not allowed by this policy` 此路由只接受开发者密钥。移除 `Authorization` 请求头及其他凭据，再重新发送。 |
| `403` | `GACHA_V3_BUILDER_NOT_ACCEPTED_ON_PUBLIC_API` | `error` | `This builder checks out on its own surface, not on the public API` 此密钥无法用于当前 API。请联系 Renaiss，无需重试。 |
| `404` | `COLLECTIBLE_NOT_FOUND` | `error` | `Collectible not found` 代币 ID 未知或藏品在该 API 中不可用。请核对 ID，不要用同一 ID 重试。 |
| `409` | `WRONG_REQUEST_PARAMS` | `error` | `Ask price changed` 传入价格与当前挂牌价不同。请刷新价格并重新准备购买。 |
| `413` | 无错误码 | `text/plain` | `Payload Too Large` |
| `429` | `API_AUTH_RATE_LIMITED` | `error` | `Authentication rate limit exceeded` 已达到密钥的请求频率上限。稍候再以较低频率重试。 |
| `500` | `API_AUTH_ERROR` | `error` | `Internal server error` |
| `500` | `FUNCTION_ERROR` | `error` | `Internal server error` |
| `500` | 无错误码 | `text/plain` | `Internal Server Error` |
| `500` | `COLLECTIBLE_GET_FAILED` | `error` | `Internal server error` 若问题持续出现，请将 `x-request-id` 提供给 Renaiss。 |


## OpenAPI

````yaml cn/api-reference/openapi.json POST /v2/marketplace/buy/prepare
openapi: 3.1.1
info:
  version: 1.0.0
  title: Renaiss 开发者 API v2
  description: >-
    在 BNB 智能链（链 ID 56）上使用外部钱包接入抽卡、交易市场和实物兑换。所有已批准且有效的开发者密钥均可准备购买。


    藏品包括钱包可抽取、交易、回售或兑换的物品，例如卡牌。接口路径、字段和描述统一使用 collectible 表示藏品。


    可以匿名浏览目录。准备购买后，请由买家钱包签名。抽卡记录和回购报价需要开发者密钥，购买和回购还需操作签名。私有配送信息及兑换需要钱包访问令牌，由钱包在已注册的合作方来源签署登录消息后签发。抽卡和市场不使用钱包访问令牌。请在后端保管开发者密钥。


    操作钱包可以是 EOA 或已部署的 ERC-1271 合约账户。不支持 EIP-7702 委托账户、ERC-6492 或 ERC-8010 封装签名及
    Renaiss 托管的 Safe（签名验证后才会识别并拒绝该类 Safe）。无法接收 ERC-721 的合约钱包抽卡会返回
    `CONTRACT_WALLET_CANNOT_RECEIVE_NFT`。链上读取失败返回
    `API_AUTH_ERROR`（500）。钱包访问令牌及实物兑换仅支持 EOA。
servers:
  - url: https://api.renaiss.xyz
    description: BNB 智能链主网
  - url: https://dev-api.renaiss.xyz
    description: BNB 测试网
security: []
tags:
  - name: Gacha v2
    description: 使用 EOA 浏览和购买卡包、揭晓藏品、读取购买记录及回购。无需钱包访问令牌。
  - name: Marketplace
    description: 公开浏览藏品，通过外部钱包挂牌、出价、购买或撤单。交易需要开发者授权及钱包操作签名。
  - name: Users
    description: 查询特定钱包的藏品、市场总估值和链上活动。仅需开发者密钥，各接口按相应的可见范围返回记录。
  - name: Redemption
    description: 查询兑换资格、运费报价，准备并提交兑换及跟踪物流。需要开发者密钥及同一钱包的访问令牌。
  - name: Wallet access tokens
    description: >-
      获取、刷新或撤销实物兑换使用的钱包访问令牌。钱包签署一次性登录消息（5 分钟有效）后，API 返回访问令牌（15 分钟）和一次性刷新令牌（7
      天）。先注册精确的合作方前端来源。抽卡和市场无需钱包访问令牌。
paths:
  /v2/marketplace/buy/prepare:
    post:
      tags:
        - Marketplace
      summary: 按展示的挂牌价准备购买
      description: 按买家已确认的卖价准备购买，获取待买家签名的订单。 调试面板使用测试网请求格式。当前主网字段见本页说明。
      requestBody:
        required: true
        content:
          application/json:
            schema:
              type: object
              properties:
                tokenId:
                  type: string
                  pattern: ^\d+$
                  description: 卡牌的链上 ID，以十进制 uint256 字符串传入。
                  example: '9007199254740993'
                walletAddress:
                  type: string
                expiresAt:
                  type:
                    - string
                    - 'null'
                  format: date-time
                  pattern: Z$
                  description: >-
                    传入 JSON `null` 表示从准备交易时起 30 天后到期，也可指定未来 180 天内、以 `Z` 结尾的 UTC
                    时间戳。每次准备交易都必须传入此字段。
                  examples:
                    - null
                expectedTotalPriceInUsdt:
                  type: string
                  pattern: ^0*[1-9][0-9]*$
                  description: 买家已确认的挂牌总价，以 USDT 的最小单位表示（18 位小数）。若挂牌价已变化，接口返回 HTTP 409。
              required:
                - tokenId
                - walletAddress
                - expiresAt
                - expectedTotalPriceInUsdt
              additionalProperties: false
            example:
              tokenId: '9007199254740993'
              walletAddress: '0x1111111111111111111111111111111111111111'
              expiresAt: null
              expectedTotalPriceInUsdt: '102000000000000000000'
      responses:
        '200':
          description: 成功
          content:
            application/json:
              schema:
                type: object
                properties:
                  operation:
                    type: string
                    enum:
                      - bid
                      - buy
                  tokenId:
                    type: string
                    pattern: ^\d+$
                  buyerWalletAddress:
                    type: string
                    description: 带 0x 前缀的 20 字节钱包或合约地址。请使用全小写或有效的校验和格式。
                  quote:
                    type: object
                    properties:
                      amountInUsdt:
                        type: string
                        pattern: ^\d+$
                      expiresAt:
                        type: string
                        format: date-time
                    required:
                      - amountInUsdt
                      - expiresAt
                  typedData:
                    type: object
                    properties:
                      domain:
                        type: object
                        additionalProperties: {}
                      types:
                        type: object
                        additionalProperties: {}
                      primaryType:
                        type: string
                      message:
                        type: object
                        additionalProperties: {}
                    required:
                      - domain
                      - types
                      - primaryType
                      - message
                  payload:
                    type: object
                    properties:
                      collectibleId:
                        type: string
                        format: uuid
                        description: 准备响应保留的兼容字段。提交订单时请省略。
                      bidData:
                        type: object
                        properties:
                          bidder:
                            type: string
                            description: 带 0x 前缀的 20 字节钱包或合约地址。请使用全小写或有效的校验和格式。
                          feeBps:
                            type: string
                            pattern: ^\d+$
                          tokenId:
                            type: string
                            pattern: ^\d+$
                          amount:
                            type: string
                            pattern: ^\d+$
                          nonce:
                            type: string
                            pattern: ^\d+$
                          deadline:
                            type: string
                            pattern: ^\d+$
                        required:
                          - bidder
                          - feeBps
                          - tokenId
                          - amount
                          - nonce
                          - deadline
                    required:
                      - collectibleId
                      - bidData
                required:
                  - operation
                  - tokenId
                  - buyerWalletAddress
                  - quote
                  - typedData
                  - payload
        '400':
          description: >-
            请求在执行前被拒绝。请求体不是合法 JSON 时返回纯文本的 HTTP 400。


            见[错误码与处理方式](/cn/api-reference/marketplace/prepare-purchase#http-errors)。
          content:
            text/plain:
              schema:
                type: string
              example: Malformed JSON in request body
            application/json:
              schema:
                type: object
                properties:
                  error:
                    type: string
                    description: 简短的错误说明。
                  code:
                    type: string
                    enum:
                      - WRONG_REQUEST_PARAMS
                      - MATCHING_ASK_NOT_FOUND
                      - MATCHING_ASK_PERMIT_NOT_FOUND
                required:
                  - error
                  - code
              example:
                error: >-
                  expiresAt must be null or a future UTC timestamp within 180
                  days
                code: WRONG_REQUEST_PARAMS
        '401':
          description: >-
            缺少开发者密钥或密钥未通过验证。


            见[错误码与处理方式](/cn/api-reference/marketplace/prepare-purchase#http-errors)。
          content:
            application/json:
              schema:
                type: object
                properties:
                  error:
                    type: string
                    description: 简短的错误说明。
                  code:
                    type: string
                    enum:
                      - API_AUTH_MISSING_CREDENTIAL
                      - API_AUTH_INVALID_CREDENTIAL
                required:
                  - error
                  - code
              example:
                error: Required authentication credential is missing
                code: API_AUTH_MISSING_CREDENTIAL
        '403':
          description: >-
            当前凭据无权执行此请求。


            见[错误码与处理方式](/cn/api-reference/marketplace/prepare-purchase#http-errors)。
          content:
            application/json:
              schema:
                type: object
                properties:
                  error:
                    type: string
                    description: 简短的错误说明。
                  code:
                    type: string
                    enum:
                      - API_AUTH_CREDENTIAL_NOT_ALLOWED
                      - GACHA_V3_BUILDER_NOT_ACCEPTED_ON_PUBLIC_API
                required:
                  - error
                  - code
              example:
                error: Credential is not allowed by this policy
                code: API_AUTH_CREDENTIAL_NOT_ALLOWED
        '404':
          description: >-
            未找到藏品。


            见[错误码与处理方式](/cn/api-reference/marketplace/prepare-purchase#http-errors)。
          content:
            application/json:
              schema:
                type: object
                properties:
                  error:
                    type: string
                    description: 简短的错误说明。
                  code:
                    type: string
                    enum:
                      - COLLECTIBLE_NOT_FOUND
                required:
                  - error
                  - code
              example:
                error: Collectible not found
                code: COLLECTIBLE_NOT_FOUND
        '409':
          description: >-
            挂牌信息已变更。


            见[错误码与处理方式](/cn/api-reference/marketplace/prepare-purchase#http-errors)。
          content:
            application/json:
              schema:
                type: object
                properties:
                  error:
                    type: string
                    description: 简短的错误说明。
                  code:
                    type: string
                    enum:
                      - WRONG_REQUEST_PARAMS
                required:
                  - error
                  - code
              example:
                error: Ask price changed
                code: WRONG_REQUEST_PARAMS
        '413':
          description: >-
            请求体超过 16 KiB。


            见[错误码与处理方式](/cn/api-reference/marketplace/prepare-purchase#http-errors)。
          content:
            text/plain:
              schema:
                type: string
              example: Payload Too Large
        '429':
          description: >-
            该开发者密钥的请求过于频繁。


            见[错误码与处理方式](/cn/api-reference/marketplace/prepare-purchase#http-errors)。
          content:
            application/json:
              schema:
                type: object
                properties:
                  error:
                    type: string
                    description: 简短的错误说明。
                  code:
                    type: string
                    enum:
                      - API_AUTH_RATE_LIMITED
                required:
                  - error
                  - code
              example:
                error: Authentication rate limit exceeded
                code: API_AUTH_RATE_LIMITED
        '500':
          description: >-
            服务端暂时失败，请稍后重试。


            见[错误码与处理方式](/cn/api-reference/marketplace/prepare-purchase#http-errors)。
          content:
            text/plain:
              schema:
                type: string
              example: Internal Server Error
            application/json:
              schema:
                type: object
                properties:
                  error:
                    type: string
                    description: 简短的错误说明。
                  code:
                    type: string
                required:
                  - error
                  - code
              example:
                error: Internal server error
                code: FUNCTION_ERROR
      security:
        - builderAuth: []
      servers:
        - url: https://dev-api.renaiss.xyz
          description: BNB 测试网
components:
  securitySchemes:
    builderAuth:
      type: apiKey
      in: header
      name: x-builder-api-key
      description: >-
        已获准使用的开发者 API 密钥，仅在后端保存。抽卡和市场的写入操作还需钱包签名，实物兑换还需钱包签署登录消息后由 API 签发的 Bearer
        令牌。

````

This documentation is built and hosted on [Mintlify](https://mintlify.com), a developer documentation platform.